
#include <stdio.h>
#include <stdlib.h>
#include "math.h"

#ifndef	M_PI
#define M_PI	3.14159265358979323846
#endif

#define ENV	"HAMMING"

static int	FirstAccess=1;
static double	Hamming=0.54;	/* ratio for generalized Hamming window */

#define M_PI2		(M_PI*M_PI)
#define delta2		(delta*delta)
#define k2		((double)k*(double)k)
#define Hamming1	(1.0-Hamming)

double	Herman(delta,k)
double	delta;
int	k;
{
	char	*env;

	if (FirstAccess) {
	    FirstAccess=0;
	    if ((env=getenv(ENV))!=NULL) Hamming=atof(env);
	}
	if (k==0)
	    return (Hamming/4.0-Hamming1/M_PI2)/delta2;
	else if (k==1 || k==(-1))
	    return -(Hamming/M_PI2-Hamming1/8.0)/delta2;
	else if (k&1)
	    return -Hamming/(M_PI2*delta2*k2);
	else
	    return -Hamming1*(k2+1.0)/(M_PI2*delta2*(k2-1.0)*(k2-1.0));
}
