
#include <stdio.h>
#include <stdlib.h>

static void	Error(msg)
char		*msg;
{
	fputs(msg,stderr); fputc('\n',stderr); exit(1);
}

static size_t	fReadRev(ptr,size,items,file)
char		*ptr;
size_t		size,items;
FILE		*file;
{
	size_t	i,j,size1=size-1,size2=size/2,read=fread(ptr,size,items,file);
	char	*p1,*p2,c;

	for (i=0; i<read; i++) {
	    for (j=0; j<size2; j++) {
		p1=ptr+j; p2=ptr+size1-j; c=(*p1); *p1=(*p2); *p2=c;
	    }
	    ptr+=size;
	}
	return read;
}

int	main(argc,argv)
int	argc;
char	**argv;
{
	unsigned short	tmp=0x1234;
	unsigned char	*ptr=(unsigned char *)&tmp;
	size_t		(*fRead)()=(*ptr==(tmp&0xff))?fread:fReadRev;
	FILE		*CTR,*BA;
	double		xCenter,yCenter,radius,CTvalue,mf,dr,dx,dy,d,min,max;
	int		x,y,loc=1;
	short		width;
	float		dFD,dOF,DSU,data;

	if (argc!=3 && argc!=7)
	    Error("usage : ctr2ba CTR {xCenter yCenter radius CTvalue} BA");

	if (argv[1][0]=='-')
	    CTR=stdin;
	else
	    if ((CTR=fopen(argv[1],"rb"))==NULL) {
		fputs(argv[1],stderr); Error(" : file not found.");
	    }

	if (argc==7) {
	    xCenter=atof(argv[2]);
	    yCenter=atof(argv[3]);
	    if ((radius=atof(argv[4]))<=0.0) Error("bad radius of FOV.");

	    CTvalue=atof(argv[5]);
	}

	do (void)fgetc(CTR); while (++loc<527);
	if ((*fRead)(&width,sizeof(width),1,CTR)==1 && width>0)
	    loc+=sizeof(width);
	else
	    Error("bad image width.");
/*
	do (void)fgetc(CTR); while (++loc<529);
*/
	(void)(*fRead)(&dFD,sizeof(dFD),1,CTR); loc+=sizeof(dFD);
	(void)(*fRead)(&dOF,sizeof(dOF),1,CTR); loc+=sizeof(dOF);
	(void)(*fRead)(&DSU,sizeof(DSU),1,CTR); loc+=sizeof(DSU);

	if (dFD<=0.0 || dOF<=0.0)
	    mf=dr=0.0;
	else {
	    mf=dFD/dOF; dr=DSU/((double)width*mf);
	}
	fprintf(stderr,"%lf\t%lf\n",mf,dr);

	if (argv[argc-1][0]=='-')
	    BA=stdout;
	else
	    if ((BA=fopen(argv[argc-1],"wb"))==NULL) {
		fputs(argv[argc-1],stderr); Error(" : file not stored.");
	    }

	fprintf(BA,"%d\t%d\n",width,width);

	do (void)fgetc(CTR); while (++loc<=1024);

	for (y=0; y<width; y++)
	for (x=0; x<width; x++) {
	    if ((*fRead)(&data,sizeof(data),1,CTR)!=1)
		d=0.0;
	    else
		if (argc==7) {
		    dx=((double)x-xCenter)/radius;
		    dy=((double)y-yCenter)/radius;
		    d=(dx*dx+dy*dy>1.0)?CTvalue:data;
		}
		else
		    d=data;

	    (void)fwrite(&d,sizeof(d),1,BA);

	    if (x==0 && y==0)
		min=max=d;
	    else {
		if (d<min) min=d;
		if (d>max) max=d;
	    }
	}
	fprintf(stderr,"%lf\t%lf\n",min,max);

	if (CTR!=stdin) fclose(CTR);
	if (BA!=stdout) fclose(BA ); return 0;
}
