
#include <stdio.h>
#include <stdlib.h>
#include "CBP.h"

static void	Error(msg)
char		*msg;
{
	fputs(msg,stderr); fputc('\n',stderr); exit(1);
}

#define LINE_LEN	512
#define RADIAN		0.01745329251994329576

#define r0	dr*(double)(1-N)/2.0	/* not used */
#define t0	0.0			/* not used */

int	main(argc,argv)
int	argc;
char	**argv;
{
	FILE	*file;
	char	line[LINE_LEN];
	int	N,M,n,m;
	double	dr,pq;
	CBP	*cbp;

	if (argc!=4) Error("usage : p2q projection_p dr filteredProjection_q");

	if (argv[1][0]=='-')
	    file=stdin;
	else
	    if ((file=fopen(argv[1],"rb"))==NULL)
		Error("projection (p) data file not found.");

	if (fgets(line,LINE_LEN,file)==NULL ||
	    sscanf(line,"%d %d",&N,&M)!=2 ||
	    N<=0 || M<=0) Error("bad number of projections.");

	if ((dr=atof(argv[2]))<=0.0) Error("bad dr.");

	if ((cbp=SetUpCBP(N,M,dr,r0,t0*RADIAN))==NULL)
	    Error("SetUpCBP() memory allocation error.");

	for (m=0; m<M; m++) for (n=0; n<N; n++) {
	    fread(&pq,sizeof(pq),1,file); cbp->pq[m][n]=pq;
	}
	if (file!=stdin) fclose(file);

	Convolution(cbp);

	if (argv[3][0]=='-')
	    file=stdout;
	else
	    if ((file=fopen(argv[3],"wb"))==NULL)
		Error("filtered projection (q) data file not stored.");

	fprintf(file,"%d\t%d\n",N,M);

	for (m=0; m<M; m++) for (n=0; n<N; n++) {
	    pq=cbp->pq[m][n]; fwrite(&pq,sizeof(pq),1,file);
	}
	if (file!=stdin) fclose(file);

	return 0;
}
